<?php
class ControllerExtensionShippingSmilePayShippingC2CUP extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/shipping/smilePay_shipping_c2cup');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('smilePay_shipping_c2cup', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=shipping', true));
		}

		$data['heading_title'] = $this->language->get('heading_title');
		$data['entry_dcvc'] = $this->language->get('entry_dcvc');
        $data['entry_verifykey'] = $this->language->get('entry_verifykey');
		$data['entry_verifykey_description'] = $this->language->get('entry_verifykey_description');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_all_zones'] = $this->language->get('text_all_zones');
		$data['text_none'] = $this->language->get('text_none');

        $data['entry_frontend_711_title'] = $this->language->get('entry_frontend_711_title');
        $data['entry_711_enabled'] = $this->language->get('entry_711_enabled');
        $data['entry_711_cost'] = $this->language->get('entry_711_cost');
        $data['entry_frontend_fami_title'] = $this->language->get('entry_frontend_fami_title');
        $data['entry_fami_enabled'] = $this->language->get('entry_fami_enabled');
        $data['entry_fami_cost'] = $this->language->get('entry_fami_cost');
        $data['group_711'] = $this->language->get('group_711');
        $data['group_fami'] = $this->language->get('group_fami');
        $data['group_genernal'] = $this->language->get('group_genernal');
        $data['title_711'] = $this->language->get('title_711');
        $data['title_fami'] = $this->language->get('title_fami');

		$data['entry_cost'] = $this->language->get('entry_cost');
		$data['entry_tax_class'] = $this->language->get('entry_tax_class');
		$data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
         
        // SmilePay data start
        $data['entry_max_total_cost'] = $this->language->get('entry_max_total_cost');
		$data['entry_min_total_cost'] = $this->language->get('entry_min_total_cost');
		
		$data['entry_enough_free'] = $this->language->get('entry_enough_free');
		$data['entry_cost_note'] = $this->language->get('entry_cost_note');
        $data['entry_frontend_title'] = $this->language->get('entry_frontend_title');
        $data['entry_rvg2c'] = $this->language->get('entry_rvg2c');
        //SmilePay data end
        $data['entry_one_page_checkout']=$this->language->get('entry_one_page_checkout'); 
      
		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

        //smilePay error data start
       /* if (isset($this->error['min_cost_over'])) {
			$data['error_min_cost_over'] = $this->error['min_cost_over'];
		} else {
			$data['error_min_cost_over'] = '';
		}
        
        if (isset($this->error['max_cost_over'])) {
			$data['error_max_cost_over'] = $this->error['max_cost_over'];
		} else {
			$data['error_warning'] = '';
		}*/
        if (isset($this->error['warning_dcvc'])) {
			$data['error_warning_dcvc'] = $this->error['warning_dcvc'];
		} else {
			$data['error_warning_dcvc'] = '';
		}
    
		if (isset($this->error['warning_verifykey'])) {
			$data['error_warning_verifykey'] = $this->error['warning_verifykey'];
		} else {
			$data['error_warning_verifykey'] = '';
		}
        if (isset($this->error['max_min_rule'])) {
			$data['error_max_min_rule'] = $this->error['max_min_rule'];
		} else {
			$data['error_max_min_rule'] = '';
		}

        if (isset($this->error['711_cost'])) {
			$data['error_711_cost'] = $this->error['711_cost'];
		} else {
			$data['error_711_cost'] = '';
		}
        if (isset($this->error['fami_cost'])) {
			$data['error_fami_cost'] = $this->error['fami_cost'];
		} else {
			$data['error_fami_cost'] = '';
		}
        
        if (isset($this->error['warning_rvg2c'])) {
			$data['error_warning_rvg2c'] = $this->error['warning_rvg2c'];
		} else {
			$data['error_warning_rvg2c'] = '';
		}
        //smilePay error data end
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_shipping'),
			'href' => $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=shipping', true),
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/shipping/smilePay_shipping_c2cup', 'token=' . $this->session->data['token'], true)
		);

		$data['action'] = $this->url->link('extension/shipping/smilePay_shipping_c2cup', 'token=' . $this->session->data['token'], true);

		$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=shipping', true);

		if (isset($this->request->post['smilePay_shipping_c2cup_cost'])) {
			$data['smilePay_shipping_c2cup_cost'] = $this->request->post['smilePay_shipping_c2cup_cost'];
		} else {
			$data['smilePay_shipping_c2cup_cost'] = $this->config->get('smilePay_shipping_c2cup_cost');
		}

	
		$this->load->model('localisation/tax_class');


		if (isset($this->request->post['smilePay_shipping_c2cup_geo_zone_id'])) {
			$data['smilePay_shipping_c2cup_geo_zone_id'] = $this->request->post['smilePay_shipping_c2cup_geo_zone_id'];
		} else {
			$data['smilePay_shipping_c2cup_geo_zone_id'] = $this->config->get('smilePay_shipping_c2cup_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['smilePay_shipping_c2cup_status'])) {
			$data['smilePay_shipping_c2cup_status'] = $this->request->post['smilePay_shipping_c2cup_status'];
		} else {
			$data['smilePay_shipping_c2cup_status'] = $this->config->get('smilePay_shipping_c2cup_status');
		}

		if (isset($this->request->post['smilePay_shipping_c2cup_sort_order'])) {
			$data['smilePay_shipping_c2cup_sort_order'] = $this->request->post['smilePay_shipping_c2cup_sort_order'];
		} else {
			$data['smilePay_shipping_c2cup_sort_order'] = $this->config->get('smilePay_shipping_c2cup_sort_order');
		}
        //smilepay start
        if (isset($this->request->post['smilePay_shipping_c2cup_dcvc'])) {
			$data['smilePay_shipping_c2cup_dcvc'] = $this->request->post['smilePay_shipping_c2cup_dcvc'];
		} else {
			$data['smilePay_shipping_c2cup_dcvc'] = $this->config->get('smilePay_shipping_c2cup_dcvc');
		}
        if (isset($this->request->post['smilePay_shipping_c2cup_verifykey'])) {
			$data['smilePay_shipping_c2cup_verifykey'] = $this->request->post['smilePay_shipping_c2cup_verifykey'];
		} else {
			$data['smilePay_shipping_c2cup_verifykey'] = $this->config->get('smilePay_shipping_c2cup_verifykey');
		}

		if (isset($this->request->post['smilePay_shipping_c2cup_max_total_cost'])) {
			$data['smilePay_shipping_c2cup_max_total_cost'] = $this->request->post['smilePay_shipping_c2cup_max_total_cost'];
		} else {
			$data['smilePay_shipping_c2cup_max_total_cost'] = $this->config->get('smilePay_shipping_c2cup_max_total_cost');
		}
        if (isset($this->request->post['smilePay_shipping_c2cup_min_total_cost'])) {
			$data['smilePay_shipping_c2cup_min_total_cost'] = $this->request->post['smilePay_shipping_c2cup_min_total_cost'];
		} else {
			$data['smilePay_shipping_c2cup_min_total_cost'] = $this->config->get('smilePay_shipping_c2cup_min_total_cost');
		}
        if (isset($this->request->post['smilePay_shipping_c2cup_free_cost'])) {
			$data['smilePay_shipping_c2cup_free_cost'] = $this->request->post['smilePay_shipping_c2cup_free_cost'];
		} else {
			$data['smilePay_shipping_c2cup_free_cost'] = $this->config->get('smilePay_shipping_c2cup_free_cost');
		}

       
        if (isset($this->request->post['smilePay_shipping_c2cup_rvg2c'])) {
			$data['smilePay_shipping_c2cup_rvg2c'] = $this->request->post['smilePay_shipping_c2cup_rvg2c'];
		} else {
			$data['smilePay_shipping_c2cup_rvg2c'] = $this->config->get('smilePay_shipping_c2cup_rvg2c');
		}
        
        if (isset($this->request->post['smilePay_shipping_c2cup_frontend_title'])) {
			$data['smilePay_shipping_c2cup_frontend_title'] = $this->request->post['smilePay_shipping_c2cup_frontend_title'];
		} else {
            if($this->config->get('smilePay_shipping_c2cup_frontend_title'))
			    $data['smilePay_shipping_c2cup_frontend_title'] = $this->config->get('smilePay_shipping_c2cup_frontend_title');
            else
                $data['smilePay_shipping_c2cup_frontend_title'] =  $this->language->get('heading_title');
		}
        //smilepay end
        // 711 start
        if (isset($this->request->post['smilePay_shipping_c2cup_711_enabled'])) {
			$data['smilePay_shipping_c2cup_711_enabled'] = $this->request->post['smilePay_shipping_c2cup_711_enabled'];
		} else {
			$data['smilePay_shipping_c2cup_711_enabled'] = $this->config->get('smilePay_shipping_c2cup_711_enabled');
		}
        if (isset($this->request->post['smilePay_shipping_c2cup_cost'])) {
			$data['smilePay_shipping_c2cup_cost'] = $this->request->post['smilePay_shipping_c2cup_cost'];
		} else {
			$data['smilePay_shipping_c2cup_cost'] = $this->config->get('smilePay_shipping_c2cup_cost');
		}

        if (isset($this->request->post['smilePay_shipping_c2cup_711_frontend_title'])) {
			$data['smilePay_shipping_c2cup_711_frontend_title'] = $this->request->post['smilePay_shipping_c2cup_711_frontend_title'];
		} else {
            if($this->config->get('smilePay_shipping_c2cup_711_frontend_title'))
			    $data['smilePay_shipping_c2cup_711_frontend_title'] = $this->config->get('smilePay_shipping_c2cup_711_frontend_title');
            else
                $data['smilePay_shipping_c2cup_711_frontend_title'] =  $this->language->get('title_711');
		}
        // 711 end

        // fami start
        if (isset($this->request->post['smilePay_shipping_c2cup_fami_enabled'])) {
			$data['smilePay_shipping_c2cup_fami_enabled'] = $this->request->post['smilePay_shipping_c2cup_fami_enabled'];
		} else {
			$data['smilePay_shipping_c2cup_fami_enabled'] = $this->config->get('smilePay_shipping_c2cup_fami_enabled');
		}
        if (isset($this->request->post['smilePay_shipping_c2cup_fami_cost'])) {
			$data['smilePay_shipping_c2cup_fami_cost'] = $this->request->post['smilePay_shipping_c2cup_fami_cost'];
		} else {
			$data['smilePay_shipping_c2cup_fami_cost'] = $this->config->get('smilePay_shipping_c2cup_fami_cost');
		}

        if (isset($this->request->post['smilePay_shipping_c2cup_fami_frontend_title'])) {
			$data['smilePay_shipping_c2cup_fami_frontend_title'] = $this->request->post['smilePay_shipping_c2cup_fami_frontend_title'];
		} else {
            if($this->config->get('smilePay_shipping_c2cup_fami_frontend_title'))
			    $data['smilePay_shipping_c2cup_fami_frontend_title'] = $this->config->get('smilePay_shipping_c2cup_fami_frontend_title');
            else
                $data['smilePay_shipping_c2cup_fami_frontend_title'] =  $this->language->get('title_fami');
		}
        // fami end
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/shipping/smilePay_shipping_c2cup.tpl', $data));
	}

	protected function validate() {

         // default  cost 60-19999
     //   define("SMILEPAY_SHIPPING_MIN_TOTOAL_COST_RANGE",60);
      //  define("SMILEPAY_SHIPPING_MAX_TOTOAL_COST_RANGE",19999);

        //$this->load->language('shipping/smilePay_shipping_c2cup');
      

        $max_cost_check_ok=false;
        $min_cost_check_ok=false;

		if (!$this->user->hasPermission('modify', 'extension/shipping/smilePay_shipping_c2cup')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
      
        if( $this->request->post['smilePay_shipping_c2cup_min_total_cost']  )
        {
           $min_cost_check_ok=true;
        }
        

        if( $this->request->post['smilePay_shipping_c2cup_max_total_cost'])
        {
            $max_cost_check_ok =true;
        }
      
        if($max_cost_check_ok &&  $min_cost_check_ok)
        {
            if($this->request->post['smilePay_shipping_c2cup_max_total_cost']  < $this->request->post['smilePay_shipping_c2cup_min_total_cost'])
              $this->error['max_min_rule'] = $this->language->get('error_max_min_rule');
        }
        
       if( $this->request->post['smilePay_shipping_c2cup_711_enabled'] != 0 && (!isset( $this->request->post['smilePay_shipping_c2cup_cost']) || $this->request->post['smilePay_shipping_c2cup_cost']=="" || $this->request->post['smilePay_shipping_c2cup_cost']<0) )
            $this->error['711_cost']= $this->language->get('error_cost');

       if( $this->request->post['smilePay_shipping_c2cup_fami_enabled'] != 0 && (!isset( $this->request->post['smilePay_shipping_c2cup_fami_cost']) || $this->request->post['smilePay_shipping_c2cup_fami_cost']=="" || $this->request->post['smilePay_shipping_c2cup_fami_cost']<0) )
            $this->error['fami_cost']= $this->language->get('error_cost');
        

       if (!$this->request->post['smilePay_shipping_c2cup_dcvc']) {

        
			$this->error['warning_dcvc'] = $this->language->get('error_dcvc');
	   }
    
	   if (!$this->request->post['smilePay_shipping_c2cup_verifykey']) {
			$this->error['warning_verifykey'] = $this->language->get('error_verifykey');
	   }
       if (!$this->request->post['smilePay_shipping_c2cup_rvg2c']) {
			$this->error['warning_rvg2c'] = $this->language->get('error_rvg2c');
	   }

	   return !$this->error;
	}


    public function install() {
			$this->load->model('extension/event');
			$this->model_extension_event->addEvent('smilePay_shipping_c2cup_filter', 'catalog/view/checkout/payment_method/before', 'extension/module/smilepay_ext/filter_payment_c2cup');
	}

	public function uninstall() {
		$this->load->model('extension/event');
		$this->model_extension_event->deleteEvent('smilePay_shipping_c2cup_filter');
	}




}