<?php
class ControllerExtensionShippingSmilePayEzcatup extends Controller {
	private $error = array();
    protected $api_token;
    protected $api_cookie_arg;

    const SMILEPAY_EZCATUP_SERVICE_TYPE = 'smilepay_ezcatup';
    const SMILEPAY_EZCATUP_SERVICE_ID_NORMAL = 'smilepay_ezcatup_normal';
    const SMILEPAY_EZCATUP_SERVICE_ID_FRIDGE = 'smilepay_ezcatup_fridge';
    const SMILEPAY_EZCATUP_SERVICE_ID_FREEZE = 'smilepay_ezcatup_freeze';


	public function index() {
		$this->load->language('extension/shipping/smilepay_ezcatup');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('smilepay_ezcatup', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=shipping', true));
		}

		$data['heading_title'] = $this->language->get('heading_title');
		$data['entry_dcvc'] = $this->language->get('entry_dcvc');
        $data['entry_verifykey'] = $this->language->get('entry_verifykey');
		$data['entry_verifykey_description'] = $this->language->get('entry_verifykey_description');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_all_zones'] = $this->language->get('text_all_zones');
		$data['text_none'] = $this->language->get('text_none');

		$data['entry_cost'] = $this->language->get('entry_cost');
		$data['entry_tax_class'] = $this->language->get('entry_tax_class');
		$data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
         
        // SmilePay data start
        $data['entry_max_total_cost'] = $this->language->get('entry_max_total_cost');
		$data['entry_min_total_cost'] = $this->language->get('entry_min_total_cost');
		
		$data['entry_enough_free'] = $this->language->get('entry_enough_free');
		$data['entry_cost_note'] = $this->language->get('entry_cost_note');
        $data['entry_frontend_title'] = $this->language->get('entry_frontend_title');
        $data['entry_rvg2c'] = $this->language->get('entry_rvg2c');
        
        $data['group_genernal'] = $this->language->get('group_genernal');
        $data['text_note'] = $this->language->get('text_note');
        
        $data['group_noraml'] = $this->language->get('group_noraml');
        $data['entry_normal_enabled'] = $this->language->get('entry_normal_enabled');
        $data['entry_normal_cost'] = $this->language->get('entry_normal_cost');
        $data['entry_frontend_normal_title'] = $this->language->get('entry_frontend_normal_title');
      
        $data['group_fridge'] = $this->language->get('group_fridge');
        $data['entry_fridge_enabled'] = $this->language->get('entry_fridge_enabled');
        $data['entry_fridge_cost'] = $this->language->get('entry_fridge_cost');
        $data['entry_frontend_fridge_title'] = $this->language->get('entry_frontend_fridge_title');

        $data['group_freeze'] = $this->language->get('group_freeze');
        $data['entry_freeze_enabled'] = $this->language->get('entry_freeze_enabled');
        $data['entry_freeze_cost'] = $this->language->get('entry_freeze_cost');
        $data['entry_frontend_freeze_title'] = $this->language->get('entry_frontend_freeze_title');

      
		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

        //smilePay error data start
       /* if (isset($this->error['min_cost_over'])) {
			$data['error_min_cost_over'] = $this->error['min_cost_over'];
		} else {
			$data['error_min_cost_over'] = '';
		}
        
        if (isset($this->error['max_cost_over'])) {
			$data['error_max_cost_over'] = $this->error['max_cost_over'];
		} else {
			$data['error_warning'] = '';
		}*/
        if (isset($this->error['warning_dcvc'])) {
			$data['error_warning_dcvc'] = $this->error['warning_dcvc'];
		} else {
			$data['error_warning_dcvc'] = '';
		}
    
		if (isset($this->error['warning_verifykey'])) {
			$data['error_warning_verifykey'] = $this->error['warning_verifykey'];
		} else {
			$data['error_warning_verifykey'] = '';
		}
        if (isset($this->error['max_min_rule'])) {
			$data['error_max_min_rule'] = $this->error['max_min_rule'];
		} else {
			$data['error_max_min_rule'] = '';
		}

       
        if (isset($this->error['warning_rvg2c'])) {
			$data['error_warning_rvg2c'] = $this->error['warning_rvg2c'];
		} else {
			$data['error_warning_rvg2c'] = '';
		}

        if (isset($this->error['normal_cost'])) {
			$data['error_normal_cost'] = $this->error['normal_cost'];
		} else {
			$data['error_normal_cost'] = '';
		}
        if (isset($this->error['fridge_cost'])) {
			$data['error_fridge_cost'] = $this->error['fridge_cost'];
		} else {
			$data['error_fridge_cost'] = '';
		}
        if (isset($this->error['freeze_cost'])) {
			$data['error_freeze_cost'] = $this->error['freeze_cost'];
		} else {
			$data['error_freeze_cost'] = '';
		}
      //smilePay error data end
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_shipping'),
			'href' => $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=shipping', true),
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/shipping/smilepay_ezcatup', 'token=' . $this->session->data['token'], true)
		);

		$data['action'] = $this->url->link('extension/shipping/smilepay_ezcatup', 'token=' . $this->session->data['token'], true);

		$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=shipping', true);

		if (isset($this->request->post['smilepay_ezcatup_cost'])) {
			$data['smilepay_ezcatup_cost'] = $this->request->post['smilepay_ezcatup_cost'];
		} else {
			$data['smilepay_ezcatup_cost'] = $this->config->get('smilepay_ezcatup_cost');
		}

	
		$this->load->model('localisation/tax_class');


		if (isset($this->request->post['smilepay_ezcatup_geo_zone_id'])) {
			$data['smilepay_ezcatup_geo_zone_id'] = $this->request->post['smilepay_ezcatup_geo_zone_id'];
		} else {
			$data['smilepay_ezcatup_geo_zone_id'] = $this->config->get('smilepay_ezcatup_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['smilepay_ezcatup_status'])) {
			$data['smilepay_ezcatup_status'] = $this->request->post['smilepay_ezcatup_status'];
		} else {
			$data['smilepay_ezcatup_status'] = $this->config->get('smilepay_ezcatup_status');
		}

		if (isset($this->request->post['smilepay_ezcatup_sort_order'])) {
			$data['smilepay_ezcatup_sort_order'] = $this->request->post['smilepay_ezcatup_sort_order'];
		} else {
			$data['smilepay_ezcatup_sort_order'] = $this->config->get('smilepay_ezcatup_sort_order');
		}
        //smilepay start
        if (isset($this->request->post['smilepay_ezcatup_dcvc'])) {
			$data['smilepay_ezcatup_dcvc'] = $this->request->post['smilepay_ezcatup_dcvc'];
		} else {
			$data['smilepay_ezcatup_dcvc'] = $this->config->get('smilepay_ezcatup_dcvc');
		}
        if (isset($this->request->post['smilepay_ezcatup_verifykey'])) {
			$data['smilepay_ezcatup_verifykey'] = $this->request->post['smilepay_ezcatup_verifykey'];
		} else {
			$data['smilepay_ezcatup_verifykey'] = $this->config->get('smilepay_ezcatup_verifykey');
		}

		if (isset($this->request->post['smilepay_ezcatup_max_total_cost'])) {
			$data['smilepay_ezcatup_max_total_cost'] = $this->request->post['smilepay_ezcatup_max_total_cost'];
		} else {
			$data['smilepay_ezcatup_max_total_cost'] = $this->config->get('smilepay_ezcatup_max_total_cost');
		}
        if (isset($this->request->post['smilepay_ezcatup_min_total_cost'])) {
			$data['smilepay_ezcatup_min_total_cost'] = $this->request->post['smilepay_ezcatup_min_total_cost'];
		} else {
			$data['smilepay_ezcatup_min_total_cost'] = $this->config->get('smilepay_ezcatup_min_total_cost');
		}
        if (isset($this->request->post['smilepay_ezcatup_free_cost'])) {
			$data['smilepay_ezcatup_free_cost'] = $this->request->post['smilepay_ezcatup_free_cost'];
		} else {
			$data['smilepay_ezcatup_free_cost'] = $this->config->get('smilepay_ezcatup_free_cost');
		}

       
        if (isset($this->request->post['smilepay_ezcatup_rvg2c'])) {
			$data['smilepay_ezcatup_rvg2c'] = $this->request->post['smilepay_ezcatup_rvg2c'];
		} else {
			$data['smilepay_ezcatup_rvg2c'] = $this->config->get('smilepay_ezcatup_rvg2c');
		}
        
        if (isset($this->request->post['smilepay_ezcatup_frontend_title'])) {
			$data['smilepay_ezcatup_frontend_title'] = $this->request->post['smilepay_ezcatup_frontend_title'];
		} else {
            if($this->config->get('smilepay_ezcatup_frontend_title'))
			    $data['smilepay_ezcatup_frontend_title'] = $this->config->get('smilepay_ezcatup_frontend_title');
            else
                $data['smilepay_ezcatup_frontend_title'] =  $this->language->get('heading_title');
		}

        // normal start
        if (isset($this->request->post['smilepay_ezcatup_normal_enabled'])) {
			$data['smilepay_ezcatup_normal_enabled'] = $this->request->post['smilepay_ezcatup_normal_enabled'];
		} else {
			$data['smilepay_ezcatup_normal_enabled'] = $this->config->get('smilepay_ezcatup_normal_enabled');
		}
        if (isset($this->request->post['smilepay_ezcatup_normal_cost'])) {
			$data['smilepay_ezcatup_normal_cost'] = $this->request->post['smilepay_ezcatup_normal_cost'];
		} else {
			$data['smilepay_ezcatup_normal_cost'] = $this->config->get('smilepay_ezcatup_normal_cost');
		}

        if (isset($this->request->post['smilepay_ezcatup_normal_frontend_title'])) {
			$data['smilepay_ezcatup_normal_frontend_title'] = $this->request->post['smilepay_ezcatup_normal_frontend_title'];
		} else {
            if($this->config->get('smilepay_ezcatup_normal_frontend_title'))
			    $data['smilepay_ezcatup_normal_frontend_title'] = $this->config->get('smilepay_ezcatup_normal_frontend_title');
            else
                $data['smilepay_ezcatup_normal_frontend_title'] =  $this->language->get('title_normal');
		}
        // normal end
        // fridge start
        if (isset($this->request->post['smilepay_ezcatup_fridge_enabled'])) {
			$data['smilepay_ezcatup_fridge_enabled'] = $this->request->post['smilepay_ezcatup_fridge_enabled'];
		} else {
			$data['smilepay_ezcatup_fridge_enabled'] = $this->config->get('smilepay_ezcatup_fridge_enabled');
		}
        if (isset($this->request->post['smilepay_ezcatup_fridge_cost'])) {
			$data['smilepay_ezcatup_fridge_cost'] = $this->request->post['smilepay_ezcatup_fridge_cost'];
		} else {
			$data['smilepay_ezcatup_fridge_cost'] = $this->config->get('smilepay_ezcatup_fridge_cost');
		}

        if (isset($this->request->post['smilepay_ezcatup_fridge_frontend_title'])) {
			$data['smilepay_ezcatup_fridge_frontend_title'] = $this->request->post['smilepay_ezcatup_fridge_frontend_title'];
		} else {
            if($this->config->get('smilepay_ezcatup_fridge_frontend_title'))
			    $data['smilepay_ezcatup_fridge_frontend_title'] = $this->config->get('smilepay_ezcatup_fridge_frontend_title');
            else
                $data['smilepay_ezcatup_fridge_frontend_title'] =  $this->language->get('title_fridge');
		}
        //fridge end

        // freeze start
        if (isset($this->request->post['smilepay_ezcatup_freeze_enabled'])) {
			$data['smilepay_ezcatup_freeze_enabled'] = $this->request->post['smilepay_ezcatup_freeze_enabled'];
		} else {
			$data['smilepay_ezcatup_freeze_enabled'] = $this->config->get('smilepay_ezcatup_freeze_enabled');
		}
        if (isset($this->request->post['smilepay_ezcatup_freeze_cost'])) {
			$data['smilepay_ezcatup_freeze_cost'] = $this->request->post['smilepay_ezcatup_freeze_cost'];
		} else {
			$data['smilepay_ezcatup_freeze_cost'] = $this->config->get('smilepay_ezcatup_freeze_cost');
		}

        if (isset($this->request->post['smilepay_ezcatup_freeze_frontend_title'])) {
			$data['smilepay_ezcatup_freeze_frontend_title'] = $this->request->post['smilepay_ezcatup_freeze_frontend_title'];
		} else {
            if($this->config->get('smilepay_ezcatup_freeze_frontend_title'))
			    $data['smilepay_ezcatup_freeze_frontend_title'] = $this->config->get('smilepay_ezcatup_freeze_frontend_title');
            else
                $data['smilepay_ezcatup_freeze_frontend_title'] =  $this->language->get('title_freeze');
		}
        //freeze end

        //smilepay end

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/shipping/smilepay_ezcatup', $data));
	}

	protected function validate() {

         // default  cost 60-19999
     //   define("SMILEPAY_SHIPPING_MIN_TOTOAL_COST_RANGE",60);
      //  define("SMILEPAY_SHIPPING_MAX_TOTOAL_COST_RANGE",19999);

        //$this->load->language('shipping/smilepay_ezcatup');
      

        $max_cost_check_ok=false;
        $min_cost_check_ok=false;

		if (!$this->user->hasPermission('modify', 'extension/shipping/smilepay_ezcatup')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
      
        if( $this->request->post['smilepay_ezcatup_min_total_cost']  )
        {
           $min_cost_check_ok=true;
        }
        

        if( $this->request->post['smilepay_ezcatup_max_total_cost'])
        {
            $max_cost_check_ok =true;
        }
      
        if($max_cost_check_ok &&  $min_cost_check_ok)
        {
            if($this->request->post['smilepay_ezcatup_max_total_cost']  < $this->request->post['smilepay_ezcatup_min_total_cost'])
              $this->error['max_min_rule'] = $this->language->get('error_max_min_rule');
        }
        
        if( $this->request->post['smilepay_ezcatup_normal_enabled'] != 0 && (!isset( $this->request->post['smilepay_ezcatup_normal_cost']) || $this->request->post['smilepay_ezcatup_normal_cost']=="" || $this->request->post['smilepay_ezcatup_normal_cost']<0) )
            $this->error['normal_cost']= $this->language->get('error_cost');

        if( $this->request->post['smilepay_ezcatup_fridge_enabled'] != 0 && (!isset( $this->request->post['smilepay_ezcatup_fridge_cost']) || $this->request->post['smilepay_ezcatup_fridge_cost']=="" || $this->request->post['smilepay_ezcatup_fridge_cost']<0) )
            $this->error['fridge_cost']= $this->language->get('error_cost');

        if( $this->request->post['smilepay_ezcatup_freeze_enabled'] != 0 && (!isset( $this->request->post['smilepay_ezcatup_freeze_cost']) || $this->request->post['smilepay_ezcatup_freeze_cost']=="" || $this->request->post['smilepay_ezcatup_freeze_cost']<0) )
            $this->error['freeze_cost']= $this->language->get('error_cost');

        

       if (!$this->request->post['smilepay_ezcatup_dcvc']) {

        
			$this->error['warning_dcvc'] = $this->language->get('error_dcvc');
	   }
    
	   if (!$this->request->post['smilepay_ezcatup_verifykey']) {
			$this->error['warning_verifykey'] = $this->language->get('error_verifykey');
	   }
       if (!$this->request->post['smilepay_ezcatup_rvg2c']) {
			$this->error['warning_rvg2c'] = $this->language->get('error_rvg2c');
	   }

	   return !$this->error;
	}

    public function getService_code() {
        return array(
                self::SMILEPAY_EZCATUP_SERVICE_ID_NORMAL => self::SMILEPAY_EZCATUP_SERVICE_TYPE . "." . self::SMILEPAY_EZCATUP_SERVICE_ID_NORMAL,
                self::SMILEPAY_EZCATUP_SERVICE_ID_FRIDGE => self::SMILEPAY_EZCATUP_SERVICE_TYPE . "." . self::SMILEPAY_EZCATUP_SERVICE_ID_FRIDGE,
                self::SMILEPAY_EZCATUP_SERVICE_ID_FREEZE => self::SMILEPAY_EZCATUP_SERVICE_TYPE . "." . self::SMILEPAY_EZCATUP_SERVICE_ID_FREEZE
                );
    }

    public function getTemperature($service_id) {
        
        $data= array(
                self::SMILEPAY_EZCATUP_SERVICE_TYPE . "." . self::SMILEPAY_EZCATUP_SERVICE_ID_NORMAL => '0001',
                self::SMILEPAY_EZCATUP_SERVICE_TYPE . "." . self::SMILEPAY_EZCATUP_SERVICE_ID_FRIDGE => '0002',
                self::SMILEPAY_EZCATUP_SERVICE_TYPE . "." . self::SMILEPAY_EZCATUP_SERVICE_ID_FREEZE => '0003'
                );
        if(isset($data[$service_id]))
        {
            return $data[$service_id];
        }
        return $data[self::SMILEPAY_EZCATUP_SERVICE_TYPE . "." . self::SMILEPAY_EZCATUP_SERVICE_ID_NORMAL];
    }

    public function getMaxLWHSize($service_id) {
        
        $data= array(
                self::SMILEPAY_EZCATUP_SERVICE_TYPE . "." . self::SMILEPAY_EZCATUP_SERVICE_ID_NORMAL => '150',
                self::SMILEPAY_EZCATUP_SERVICE_TYPE . "." . self::SMILEPAY_EZCATUP_SERVICE_ID_FRIDGE => '120',
                self::SMILEPAY_EZCATUP_SERVICE_TYPE . "." . self::SMILEPAY_EZCATUP_SERVICE_ID_FREEZE => '120'
                );
        if(isset($data[$service_id]))
        {
            return $data[$service_id];
        }
        return $data[self::SMILEPAY_EZCATUP_SERVICE_TYPE . "." . self::SMILEPAY_EZCATUP_SERVICE_ID_NORMAL];
    }

    public function convertPackageSize($lwh) {
        $packagea_size  = "";
        if($lwh <= 60 )
            $packagea_size = "0001";
        elseif($lwh>60 && $lwh <= 90)
            $packagea_size = "0002";
        elseif($lwh>90 && $lwh <= 120)
            $packagea_size = "0003";
        elseif($lwh>120 && $lwh <= 150)
            $packagea_size = "0004";

        return  $packagea_size;
    }

    public function is_smilepay_ezcatup($order_id=0)
    {
  
        
        if(!isset($order_id))  return false;

        $this->load->model('sale/order');
        $order_info = $this->model_sale_order->getOrder($order_id );

        $service_id = $this->getService_code();
       
        if( !in_array($order_info['shipping_code'], $service_id) ) 
          return false;

        return true;
    }

    public function createSmilePayOrderProcess($order_id)
    {

        $this->load->model('sale/order');
        $order_info = $this->model_sale_order->getOrder($order_id );

        $this->load->model('smilepay/smilepay_ezcatup');
		$order_data = $this->model_smilepay_smilepay_ezcatup->loadOrderData($order_id);

        
      
        if($this->is_smilepay_ezcatup($order_id))
        {
            if(empty($order_data['smseid']))
            {
                $smseid_result = $this->createSmilePayOrderSmseidProcess($order_id);
                if($smseid_result['Status'] != 1)
                {
                    return $smseid_result;
                }
            }

            $sp_length = $_REQUEST['sp_length'];
            $sp_width = $_REQUEST['sp_width'];
            $sp_height = $_REQUEST['sp_height'];
            $lwh = intval( round($sp_length + $sp_width + $sp_height));

           
            if(empty($order_data['track_num'])  )
            {
                $track_result = $this->createSmilePayOrderTracknumProcess($order_id,$lwh);
                if($track_result['Status'] != 1)
                {
                    return $track_result;
                }
                return $track_result;
            }
            
        }
        else
            return array(
                        'Status' =>'-10009',
                        'Desc' => 'shipping_method error'
                    );

 
         return array('Status'=>"1");
       

    }

    protected function createSmilePayOrderSmseidProcess($order_id)
    {

        $this->load->model('sale/order');
        $order_info = $this->model_sale_order->getOrder($order_id );

        $this->load->language('extension/shipping/smilepay_ezcatup');

        $this->load->model('smilepay/smilepay_ezcatup');
		$order_data = $this->model_smilepay_smilepay_ezcatup->loadOrderData($order_id);

      
        $result_order = $this->createSmilePayOrderSmseid($order_id);
        if(!is_array( $result_order))
        {
            $result = array(
                        'Status' => '-10000',
                        'Desc' =>  'response empty or connect fail'
                       );
            return $result; 
                           
        }
		elseif(isset($result_order['Status']) && $result_order['Status']=="1")
	    {
            $order_data['order_id'] = $order_id;
            $order_data['smseid'] = $result_order['SmilePayNO'];
            $this->model_smilepay_smilepay_ezcatup->saveOrderData($order_data);
           
            $message = sprintf( $this->language->get('message_smilepay_ezcat_smseid'),  $order_data['smseid']); 
            $this->addOrderHistory($order_id,$message,0,$order_info['order_status_id']);
            return $result_order;
        }
        else
        {
            return  $result_order;
        }

    }
    protected function createSmilePayOrderTracknumProcess($order_id,$lwh)
    {
        $this->load->model('sale/order');
        $order_info = $this->model_sale_order->getOrder($order_id );
         $this->load->language('extension/shipping/smilepay_ezcatup');
        $this->load->model('smilepay/smilepay_ezcatup');
		

      
        $result_track = $this->createSmilePayOrderTracknum($order_id,$lwh);

        if(!is_array( $result_track))
        {
            $result = array(
                        'Status' => '-10000',
                        'Desc' =>  'response empty or connect fail'
                       );
            return $result; 
                           
        }
		elseif(isset($result_track['Status']) && $result_track['Status']=="1")
	    {
            $order_data = $this->model_smilepay_smilepay_ezcatup->loadOrderData($order_id);
            $order_data['order_id'] = $order_id;
            $order_data['track_num'] = $result_track['TrackNum'];
            $this->model_smilepay_smilepay_ezcatup->saveOrderData($order_data);
            $message = sprintf( $this->language->get('message_smilepay_ezcat_tracknum'),  $order_data['track_num']); 
            $this->addOrderHistory($order_id,$message,1,$order_info['order_status_id']);
            return $result_track;
        }
        else
        {
            return  $result_track;
        }
    }


    protected function createSmilePayOrderSmseid($order_id)
    {
         if(!$this->is_smilepay_ezcatup($order_id))
            return 0;

         if(!$this->check_smilepayarg())
         {
             return array(
                        'Status'=>'-10002',
                        'Desc'=>'SmilePay Arg(Ex:dcvc) is not setting',
                    );
         }
         $this->load->model('sale/order');
         $order_info = $this->model_sale_order->getOrder($order_id );

         $data=array();

         $smilepay_gateway = 'https://ssl.smse.com.tw/api/sppayment.asp';

         $temperature = $this->getTemperature($order_info['shipping_code']);
         $data['Mobile_number']=  $order_info['telephone'];
         $data['Od_sob'] =   $order_id;	   		    
         $data['Dcvc']    =$this->config->get('smilepay_ezcatup_dcvc'); 
         $data['Rvg2c']   =$this->config->get('smilepay_ezcatup_rvg2c'); 
   	     $data['Pay_zg']    = '82';
         $data['Data_id']   = $order_id;			
		
         $data['Amount']    =  intval(round($order_info['total']));
		 $data['Pur_name']  =  $order_info['shipping_firstname']  . $order_info['shipping_lastname'];    
   	     $data['Email']     =  $order_info['email'];
         
		 $data['Tel_number']   =  $order_info['telephone'];			                                     		
         $data['Verify_key']= $this->config->get('smilepay_ezcatup_verifykey');
         $data['Roturl_status']= "ocart2.1.1";            
         $data['Pay_gdry']= 'TW';	 
         $data['Address']= $order_info['shipping_zone']." ". $order_info['shipping_city']. $order_info['shipping_address_1']. $order_info['shipping_address_2'];
         $data['temperature']=$temperature;

         $ch = curl_init();
		 curl_setopt($ch, CURLOPT_URL, $smilepay_gateway);
		 curl_setopt($ch, CURLOPT_VERBOSE, 1);
		 curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		 curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
		 curl_setopt($ch, CURLOPT_POST, 1);
		 curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		 curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query( $data));
		 $string = curl_exec($ch);
	     curl_close($ch);
         $xml = simplexml_load_string($string);
	     $Status = $xml->Status;
      
         if($xml !== false)
            return (array)$xml;
         else
            return  $string;

    }

    protected function createSmilePayOrderTracknum($order_id,$lwh)
    {
         if(!$this->is_smilepay_ezcatup($order_id))
            return 0;
         if(!$this->check_smilepayarg())
         {
             return array(
                        'Status'=>'-10002',
                        'Desc'=>'SmilePay Arg(Ex:dcvc) is not setting',
                    );
         }
         $this->load->model('sale/order');
         $order_info = $this->model_sale_order->getOrder($order_id );

         $max_lwh = $this->getMaxLWHSize($order_info['shipping_code']);

         if($max_lwh < $lwh)
         {
             
             $result = array(
                                'Status' => '-10300',
                                'Desc' =>  'Error package size'
                            );
             return $result; 
         }
         $this->load->model('smilepay/smilepay_ezcatup');
		 $order_data = $this->model_smilepay_smilepay_ezcatup->loadOrderData($order_id);
       

         if( empty($order_data['smseid']))
         {
            $result = array(
                        'Status' => '-10202',
                        'Desc' =>  'No Smseid Re-run the Process.'
                            );
            return $result; 
         }
         $packagea_size = $this->convertPackageSize($lwh);
         
         $smilepay_gateway = 'https://ssl.smse.com.tw/api/ezcatGetTrackNum.asp';
         $post_data = array();
         $post_data['Dcvc'] =  $this->config->get('smilepay_ezcatup_dcvc');
         $post_data['Rvg2c'] = $this->config->get('smilepay_ezcatup_rvg2c');
         $post_data['Verify_key'] = $this->config->get('smilepay_ezcatup_verifykey');
         $post_data['smseid'] = $order_data['smseid'];
         $post_data['package_size'] = $packagea_size;
         $post_data['delivery_date'] = date ('Y-m-d', mktime(0, 0, 0, date("m")  , date("d")+1, date("Y")));
         $post_data['delivery_timezone'] = "4";
                  
        

         $ch = curl_init();
		 curl_setopt($ch, CURLOPT_URL, $smilepay_gateway);
		 curl_setopt($ch, CURLOPT_VERBOSE, 1);
		 curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		 curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
		 curl_setopt($ch, CURLOPT_POST, 1);
		 curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		 curl_setopt($ch, CURLOPT_POSTFIELDS,http_build_query( $post_data) );
		 $string = curl_exec($ch);
	     curl_close($ch);
         $xml = simplexml_load_string($string);
	     $Status = $xml->Status;
      
         if($xml !== false)
            return (array)$xml;
         else
            return  $string;

    }
    public function addOrderHistory($order_id,$message='',$notify='0',$order_status_id=0)
    {
        $catalog_url = $this->request->server['HTTPS'] ? HTTPS_CATALOG : HTTP_CATALOG;
		$catalog_url .=	'index.php';
        $data['route'] = 'api/order/history';
		// API login
		
		$this->load->model('user/api');

		$api_info = $this->model_user_api->getApi($this->config->get('config_api_id'));

		if ($api_info) {
			
			$api_id = $api_info['api_id'];
			$api_key = $api_info['key'];
			$api_ip = $this->request->server['REMOTE_ADDR'];
		} else {
			$api_id = '';
			$api_key = '';
			$api_ip = '';
		}

        $this->load->model('sale/order');
        $order_info = $this->model_sale_order->getOrder($order_id );

        
        $data['token'] = $this->session->data['token'];
        $data['store_id'] = $order_info['store_id'];
        
        if( empty($order_status_id))
        {
            
            $post_data['order_status_id'] = $order_info['order_status_id'];
        }
        else
            $post_data['order_status_id'] = $order_status_id;
       

        $data['order_id'] = $order_id;
        $post_data['notify'] = $notify;
        $post_data['comment'] = $message;
        $post_data['override']  = '0';

        if(!isset($this->api_token) || empty($this->api_token))
        {
            $api_login_route='api/login';
            $login_post_data = array(
                                    'key' =>  $api_key
                                    );
        

            $ch_login =  curl_init();
            curl_setopt($ch_login, CURLOPT_URL, $catalog_url."?route=".$api_login_route);
		    curl_setopt($ch_login, CURLOPT_VERBOSE, 1);
		    curl_setopt($ch_login, CURLOPT_SSL_VERIFYPEER, FALSE);
		    curl_setopt($ch_login, CURLOPT_SSL_VERIFYHOST, FALSE);
		    curl_setopt($ch_login, CURLOPT_POST, 1);
		    curl_setopt($ch_login, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch_login, CURLOPT_HEADER  ,1);
		    curl_setopt($ch_login, CURLOPT_POSTFIELDS,http_build_query( $login_post_data) );
            $api_login_result = curl_exec($ch_login);
            $api_login_result_header_size = curl_getinfo($ch_login, CURLINFO_HEADER_SIZE);
            curl_close($ch_login);
            //print_r( $api_login_result);
            if($api_login_result)
            {
                
                $api_login_result_header = substr($api_login_result, 0, $api_login_result_header_size);
                $api_login_result_body = substr($api_login_result, $api_login_result_header_size);

                $api_login_data = json_decode($api_login_result_body);
                if( isset($api_login_data->token))
                {
                    $this->api_token = $api_login_data->token;
                    
                }
                else
                    return NULL;
            }
            else
            {
                return NULL;
            }
            preg_match_all('/^Set-Cookie:\s*([^;]*)/mi', $api_login_result_header, $matches);
            $api_cookies = array();
            $api_cookies_str ="";
            foreach($matches[1] as $item) {
                echo print_r($item,true)."<br>";
                parse_str($item, $cookie);
                $api_cookies = array_merge($api_cookies, $cookie);
            }
            //avoid reapeat arg
            foreach($api_cookies as $key=>$val)
            {
                $api_cookies_str .= $key ."=".$val . "; "; 
            }
            $this->api_cookie_arg=$api_cookies_str;
        }
        if(!empty($this->api_token))
        {
            $data['token'] =  $this->api_token;
            $api_cookies_str= $this->api_cookie_arg;
        }
       
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_COOKIE,$api_cookies_str);
        curl_setopt($ch, CURLOPT_URL, $catalog_url."?".http_build_query( $data));
		curl_setopt($ch, CURLOPT_VERBOSE, 1);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS,http_build_query( $post_data) );
		$string = curl_exec($ch);
	    curl_close($ch);
       
    }
    public function check_smilepayarg()
    {
        if(empty($this->config->get('smilepay_ezcatup_dcvc')) || empty($this->config->get('smilepay_ezcatup_rvg2c')) ||empty($this->config->get('smilepay_ezcatup_verifykey')) )
            return false;
        else
            return TRUE;
    }


    public function install() {
            $this->load->model('smilepay/smilepay_ezcatup');
		    $this->model_smilepay_smilepay_ezcatup->install();

			
            $this->load->model('user/user_group');
            //admin controller permission
	        $this->model_user_user_group->addPermission($this->user->getGroupId(), 'access', 'smilepay/order');
            $this->model_user_user_group->addPermission($this->user->getGroupId(), 'access', 'smilepay/service');
			
			//$this->model_setting_event->addEvent('smilepay_ezcatup_filter', 'catalog/view/checkout/payment_method/before', 'extension/module/smilepay_ext/filter_payment_ezcatup');
	}

	public function uninstall() {
		$this->load->model('setting/event');
		//$this->model_setting_event->deleteEventByCode('smilepay_ezcatup_filter');
	}




}