<?php
class ControllerExtensionPaymentSmilePay711c2cup extends Controller {
    const SMILEPAY_C2CUP_SERVICE_TYPE = 'smilePay_shipping_c2cup';
    const SMILEPAY_C2CUP_SERVICE_ID_711 = 'smilePay_shipping_c2cup';
    const SMILEPAY_C2CUP_SERVICE_ID_FAMI = 'fami';

    protected $map_url = array(
                   '711' => array(
                                'mobile'=>'https://emap.presco.com.tw/c2cemapm-u.ashx?eshopid=870&servicetype=1&tempvar=%s&url=%s',
                                'normal'=>'https://emap.presco.com.tw/c2cemap.ashx?eshopid=870&servicetype=1&tempvar=%s&url=%s'
                                 ),
                   'fami'=>  array(
                                'mobile'=>'https://ssl.smse.com.tw/api/LogisticsEmap.asp?TypesServer=FAMIC2C&TypesInterface=WEB&tempvar=%s&url=%s',
                                'normal'=>'https://ssl.smse.com.tw/api/LogisticsEmap.asp?TypesServer=FAMIC2C&TypesInterface=WEB&tempvar=%s&url=%s'
                                 )
                    );
	public function index()
    {
        //echo "Nop";
    }

    // connect e-map
    public function goemap()
    {
        //clear last data.
        $this->clearC2cupDataToSession();
        
        if(is_null($_REQUEST['order_id'])||empty($_REQUEST['order_id'])) 
        {
            echo "error format";
            exit;
        }
         
        if(!$this->is_smilepay_711c2cup($_REQUEST['order_id']))
        {
            echo "shipping error!";
            exit;
        }
        $urlmap = $this->getEMapUrl($this->url->link('extension/payment/smilepay_711c2cup/resultview', '', true),$_REQUEST['order_id']);   
        $this->response->redirect($urlmap);

    }
    //Conncet to E-map. It's because of one page checkout to modify
    //input of post param:
    //               continue: redirect after come back from E-MAP process
    //return: NONE
    public function goemapdirect()
    {
        //clear last data.
        $this->clearC2cupDataToSession();
        
        if(!$this->is_smilepay_711c2cup_now())
        {
            exit('Error shipping code');
        }
        
        if(isset($_REQUEST['continue']))
           $this->session->data['smilepay_71c2cup_data']['smilepay_711c2cup_rtl']=$_REQUEST['continue'];
        //map mobile start
        $urlmap = $this->getEMapUrl($this->url->link('extension/payment/smilepay_711c2cup/return_process', '', true));  
        $this->response->redirect($urlmap);

    }

    //Conncet to E-map and save the parameter. It's because of one page checkout to modify
    //input of post param:
    //               Any post data,
    //               continue: redirect after come back from E-MAP process and send saving.
    //return: NONE
    public function goemapwithparam()
    {
        //clear last data.
        $this->clearC2cupDataToSession();
        $this->session->data['smilepay_71c2cup_data']['form_param']=$_REQUEST;

        if(!$this->is_smilepay_711c2cup_now())
        {
            exit('Error shipping code');
        }
        
        if(isset($_REQUEST['continue']))
           $this->session->data['smilepay_71c2cup_data']['smilepay_711c2cup_rtl']=$_REQUEST['continue'];
        
        if(isset($_REQUEST['continue']))
           $this->session->data['smilepay_71c2cup_data']['smilepay_711c2cup_rtl']=$_REQUEST['continue'];
        $urlmap=$this->getEMapUrl($this->url->link('extension/payment/smilepay_711c2cup/return_process_with_param', '', true));   
        $this->response->redirect($urlmap);

    }

    //come from E-Map and set data. Go next Url from saving data of goemapwithparam
    //
    public function return_process_with_param()
    {
        $this->language->load('extension/payment/smilepay_711c2cup'); 
        $this->load->model('checkout/order');
        $rtlurl=$this->session->data['smilepay_71c2cup_data']['smilepay_711c2cup_rtl'];
        $order_id= $this->session->data['order_id']; 
        $order_info = $this->model_checkout_order->getOrder($order_id);
        //clear 
       
        unset($this->session->data['smilepay_71c2cup_data']['smilepay_711c2cup_rtl']);

       $data=array('formdata' => $this->session->data['smilepay_71c2cup_data']['form_param'],'contiune'=>$rtlurl);

        $data['sub_title'] = $this->language->get('text_sub_title');
        $emapdata = array(
                    'storeid' => $_REQUEST['storeid'],
                    'storename' => $_REQUEST['storename'],
                    'storeaddress' => $_REQUEST['storeaddress']
                        );
        $this->saveC2cupDataToSession($emapdata);

        $this->modifyOrderAddress($order_id);


      
        $this->response->setOutput($this->load->view('extension/payment/smilepay_711c2cup_emap_with_param.tpl', $data));
    }
    // Set data of E-Map and Go next Url from saving data of goemapdirect
    //
    public function return_process()
    {
        $this->language->load('extension/payment/smilepay_711c2cup'); 
        $this->load->model('checkout/order');
        $rtlurl=$this->session->data['smilepay_71c2cup_data']['smilepay_711c2cup_rtl'];
        $order_id= $this->session->data['order_id']; 
        $order_info = $this->model_checkout_order->getOrder($order_id);
        //clear 
        unset($this->session->data['smilepay_71c2cup_data']['smilepay_711c2cup_rtl']);
        $data['sub_title'] = $this->language->get('text_sub_title');
        $emapdata = array(
                    'storeid' => $_REQUEST['storeid'],
                    'storename' => $_REQUEST['storename'],
                    'storeaddress' => $_REQUEST['storeaddress']
                        );
        $this->saveC2cupDataToSession($emapdata);

        $this->modifyOrderAddress($order_id);
      


         $this->response->redirect($rtlurl);
        
         exit();
    }

   


    // please call it after order created.
    // connect to smse.
    // create shipping order.
    // argument => order_id: order id. if order_id is 0 will return empty;
    // return: view after process
    public function runsmseprocess($order_id=0)
    {
         $this->language->load('extension/payment/smilepay_711c2cup');   
         $this->load->model('checkout/order');
         
         if(empty($order_id))
            return 0;
         if(!$this->is_smilepay_711c2cup($order_id))
            return 0;

		 $order_info = $this->model_checkout_order->getOrder($order_id);
         $data=array();
         $smilepay_711c2cupdata = $this->session->data['smilepay_71c2cup_data'];



         $data['Mobile_number']=  $order_info['telephone'];
         $data['C2cstore'] = $smilepay_711c2cupdata['storeid']. "/" .$smilepay_711c2cupdata['storename']."/".$smilepay_711c2cupdata['storeaddress'];
        
         $data['Od_sob'] =   $order_id;	
         $data['action']  = 'https://ssl.smse.com.tw/ezpos/mtmk_utf.asp';           		    
         $data['Dcvc']    =$this->config->get('smilePay_shipping_c2cup_dcvc'); 
         $data['Rvg2c']   =$this->config->get('smilePay_shipping_c2cup_rvg2c'); 
   	     $data['Pay_zg']    = '52';//付款方式
         $data['Data_id']   = $order_id;	//賣家自訂交易編號    			
		
         $data['Amount']    =  intval(round($order_info['total']));
		 $data['Pur_name']  =  mb_substr($order_info['firstname'].$order_info['lastname'],0,5,"utf-8");    
   	     $data['Email']     =  $order_info['email'];
         $data['Address']   =  '';		
		 $data['Tel_number']   =  $order_info['telephone'];			                                     		
         $data['Verify_key']= $this->config->get('smilePay_shipping_c2cup_verifykey');
       
         $data['Roturl_status']= "ocart2.1.1";            
         $data['Pay_gdry']= 'TW';	 
         $this->load->model('extension/shipping/smilePay_shipping_c2cup');  
         $arg_table = $this->model_extension_shipping_smilePay_shipping_c2cup->get_smilepay_c2cup_type();
         if(isset($order_info['shipping_code']))
         {
            if(isset($arg_table[$order_info['shipping_code']]))
                $data['Pay_subzg'] = $arg_table[$order_info['shipping_code']];
            else
                $data['Pay_subzg'] = '';
         }     
         else
            $data['Pay_subzg'] = '';

         //avoid repeat set order
         if(!isset($this->session->data['smilepay_71c2cup_data']['runonce']) )  
         {
             if(isset($this->session->data['smilepay_71c2cup_data']['storeid']) &&  isset($this->session->data['smilepay_71c2cup_data']['storename']) && isset($this->session->data['smilepay_71c2cup_data']['storeaddress']))
             {
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL,'http://ssl.smse.com.tw/api/sppayment.asp');
                curl_setopt($ch, CURLOPT_VERBOSE, 1);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
                curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
                curl_setopt($ch,CURLOPT_POSTFIELDS,    http_build_query( $data));
      
                $strAuth= curl_exec($ch);
                if (curl_errno($ch)) {
                	$strAuth = false;
                }
             
                curl_close($ch);
                if(isset($strAuth)) {
      	        // 分解字串
      	         //var_dump($strAuth);
        		    $xml = simplexml_load_string($strAuth);
      			    $Status = $xml->Status;
      			
                    if ($Status=="1") {
              // $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], $this->config->get('smilepay_atm_order_status_id')); 
                        (strlen($xml->PayEndDate) >8 ) ? $xmlPayEndDate=$xml->PayEndDate : $xmlPayEndDate="" ;                     
                        $params = array(
                                    'PayEndDate' =>urlencode($xmlPayEndDate),
                                    'Amount' => strval($xml->Amount),
                                    'Data_id' => strval($xml->Data_id),
                                    'Status' =>strval($xml->Status),
                                    'SmilePayNO' => strval($xml->SmilePayNO),
                                    );   
               //$comment= sprintf($this->language->get('text_paymessage'),$xml->AtmBankNo.'-'.$xml->AtmNo,$xmlPayEndDate);                        
                    }else{    
                        $params = array(
                            'Status'=>strval($xml->Status),
                            'Desc'=>strval($xml->Desc),
                            'Data_id'=>strval($xml->Data_id),
                         );   
                    } 
                 } else {
                    $params = array(
                            'Status'=>'-1000',
                            'Desc'=>'取號失敗',    
                            'Data_id'=> $order_id,
                            );     
                  }
              
                  $this->session->data['smilepay_71c2cup_data']['params'] =$params;
             }
             else
             {
                  $params = array(
                        'Status'=>'fail',
                        'Desc'=>'門市資料遺失',    
                        'Data_id'=> $order_id,
                        );    
                  $this->session->data['smilepay_71c2cup_data']['params'] =$params;
            }   
                
         } 
        
         $params=$this->session->data['smilepay_71c2cup_data']['params'];
        

         if($params['Status']!=1)
         {
            $comment =  sprintf($this->language->get('text_error_comment_format'),$smilepay_711c2cupdata['storeid'],$smilepay_711c2cupdata['storename'],$params['Status'],$params['Desc']);
            if( !isset($this->session->data['smilepay_71c2cup_data']['runonce']) || !$this->session->data['smilepay_71c2cup_data']['runonce'])
            {
                $this->model_checkout_order->addOrderHistory($order_id,$order_info['order_status_id'],  $comment); 
            }
          //  $data['view']['main_info']= $this->language->get('text_error_store_checkout_info');  //error comment
         }
         else
         {
            $cvs_store_name = $this->getCVSStoreNameTable();
            $comment= sprintf($this->language->get('text_view_store_info_comment_format'),$params['SmilePayNO'],$smilepay_711c2cupdata['storeid'],$smilepay_711c2cupdata['storename'],$params['SmilePayNO'],$data['Dcvc'] ,$data['Verify_key'],$data['Pay_subzg']);   
            $commentnotify = sprintf($this->language->get('text_view_store_info_customer_comment_format'),$order_info['firstname'].$order_info['lastname'], $order_info['telephone'],$smilepay_711c2cupdata['storeid'],$cvs_store_name[$order_info['shipping_code']],$smilepay_711c2cupdata['storename'],$smilepay_711c2cupdata['storeaddress']);
            if( !isset($this->session->data['smilepay_71c2cup_data']['runonce']) || !$this->session->data['smilepay_71c2cup_data']['runonce'])
            {
                $this->model_checkout_order->addOrderHistory($order_id,$order_info['order_status_id'],  $comment); 
                $this->model_checkout_order->addOrderHistory($order_id,$order_info['order_status_id'], $commentnotify,true); 
            }
            //sucess comment
            
            $data['view']['main_info']= sprintf($this->language->get('text_view_store_checkout_info_format'),$order_info['firstname'].$order_info['lastname'], $order_info['telephone'],$cvs_store_name[$order_info['shipping_code']],$smilepay_711c2cupdata['storename'],$smilepay_711c2cupdata['storeid'],$smilepay_711c2cupdata['storeaddress']);
         }

         $this->session->data['smilepay_71c2cup_data']['runonce'] = true;

     
      	 return $this->load->view('extension/payment/smilepay_711c2cup_view', $data['view']);
    }

    protected function getConvertServiceTable()
    {

        return array(
                     self::SMILEPAY_C2CUP_SERVICE_TYPE ."." . self::SMILEPAY_C2CUP_SERVICE_ID_711 => '711',
                     self::SMILEPAY_C2CUP_SERVICE_TYPE ."." . self::SMILEPAY_C2CUP_SERVICE_ID_FAMI => 'fami'
                );
    }
    protected function getCVSStoreNameTable()
    {
        $this->language->load('extension/payment/smilepay_711c2cup');   
        return array(
                     self::SMILEPAY_C2CUP_SERVICE_TYPE ."." . self::SMILEPAY_C2CUP_SERVICE_ID_711 => $this->language->get('text_store_711'),
                     self::SMILEPAY_C2CUP_SERVICE_TYPE ."." . self::SMILEPAY_C2CUP_SERVICE_ID_FAMI => $this->language->get('text_store_fami')
                );
    }
    protected function getEMapUrl($ret_url,$tempvar='')
    {
        //map mobile start
        $useragent=$_SERVER['HTTP_USER_AGENT'];
        if( strpos( $useragent,'Android') === false && strpos($useragent,'iPad' ) === false && strpos( $useragent,'iPhone') === false
	        || strpos( $useragent,'Safari') === false && strpos( $useragent,'AppleWebKit') === false  && strpos( $useragent,'Dalvik') === false )
        {
            //pc
            $type = "normal";
        }
        else
        {
            $type = "mobile";
        }
        //map mobile end
        $service_table = $this->getConvertServiceTable();

        if(isset($this->session->data['shipping_method']['code']) && isset($service_table[$this->session->data['shipping_method']['code']]))
        {
           return sprintf($this->map_url[$service_table[$this->session->data['shipping_method']['code']]][$type],$tempvar,$ret_url);
        }
        else
            return '';
    }

     // finish call it
     public function clearData()
     {
         $this->clearC2cupDataToSession();
     }

    //save data
    protected function saveC2cupDataToSession($emapdata)
    {
        if(is_null($this->session->data['smilepay_71c2cup_data']))
            $this->session->data['smilepay_71c2cup_data'] = array();

        foreach($emapdata as $key=>$val)
        {
            $this->session->data['smilepay_71c2cup_data'][$key]=$val;
        }
        
       

    }



    //clear session data
    protected function clearC2cupDataToSession()
    {
         unset($this->session->data['smilepay_emap_ok']);
         unset($this->session->data['smilepay_71c2cup_data']);
    }
    // show emap results
    public function resultview()
    {
        $this->language->load('extension/payment/smilepay_711c2cup');   

        $this->load->model('checkout/order'); 
        $order_id= $this->session->data['order_id'];
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
        $data['error']="";
        $this->document->setTitle($this->language->get('text_title'));
  	  
        
        if(!isset($_REQUEST['storeid'])|| !isset($_REQUEST['storename']) || !isset($_REQUEST['storeaddress']))
        {
            if(isset($this->session->data['smilepay_71c2cup_data']['storeid']) &&  isset($this->session->data['smilepay_71c2cup_data']['storename']) && isset($this->session->data['smilepay_71c2cup_data']['storeaddress']))
            {
                $data['sub_title'] = $this->language->get('text_sub_title');
                $data['info'] = sprintf($this->language->get('text_view_store_info_format'),$this->session->data['smilepay_71c2cup_data']['storeid'],$this->session->data['smilepay_71c2cup_data']['storename'],$this->session->data['smilepay_71c2cup_data']['storeaddress']);
            }
            else
            {
                $data['sub_title'] = $this->language->get('text_error_sub_title');
                $data['error'] =  $this->language->get('text_error_emap_ret');
            }
           
        }
        else
        {
            //save data to session
            $data['sub_title'] = $this->language->get('text_sub_title');
            $emapdata = array(
                    'storeid' => $_REQUEST['storeid'],
                    'storename' => $_REQUEST['storename'],
                    'storeaddress' => $_REQUEST['storeaddress']
               );
            $this->saveC2cupDataToSession($emapdata);
        
            $data['info'] = sprintf($this->language->get('text_view_store_info_format'),$_REQUEST['storeid'],$_REQUEST['storename'],$_REQUEST['storeaddress']);
         

            //set E-Map ok
            $this->session->data['smilepay_emap_ok'] = 'Y';
        }

        $data['text_close_button'] = $this->language->get('text_close_button');

        $data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');
	  
        $this->response->setOutput($this->load->view('extension/payment/smilepay_711c2cup.tpl', $data));
    }
    //check E-map is selected
    public function emapselected()
    {
        $json = array();
        if (!isset($this->session->data['smilepay_emap_ok']))
           $json['status'] ='N';
        elseif ($this->session->data['smilepay_emap_ok'] =='Y') 
            $json['status'] ='Y';
        else
            $json['status'] ='N';
        $this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
    }

    //validate data Name and phone
    //if $returnval =true,return json data for function
    //else output json data
    public function validate_data($returnval=false)
    {
        $this->load->model('checkout/order');  
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
        if(!isset($order_info))
        {
            $order_info=array();
            $order_info['lastname'] = $this->session->data['shipping_address']['lastname'];
             $order_info['firstname'] = $this->session->data['shipping_address']['firstname'];
        }
        $this->language->load('extension/payment/smilepay_711c2cup');   
        if(!isset($order_info['telephone']))
        {
             $json['error'] = $this->language->get('text_error_phone_validate').$order_info['telephone']; 
             $this->response->addHeader('Content-Type: application/json');
	    $this->response->setOutput(json_encode($json));
        exit();
        }
        //name rule
        //name rule
        if( !preg_match("/[^a-zA-Z0-9 ]/",$order_info['firstname']. $order_info['lastname']))
        {
           $limit_name_number =10;
        }
        else
        {
           $limit_name_number =5;
        }

        if(mb_strlen($order_info['firstname'].$order_info['lastname'])>$limit_name_number)
          $json['error'] = $this->language->get('text_error_name_validate').$order_info['firstname'].$order_info['lastname']; 
        elseif (!preg_match("/^[0][9][0-9]{8,8}$/",$order_info['telephone']))  // phone rule
          $json['error'] = $this->language->get('text_error_phone_validate').$order_info['telephone']; 
       // echo json_encode( $json);
        $json['status'] = 'ok';
        if($returnval) return $json;
        $this->response->addHeader('Content-Type: application/json');
	    $this->response->setOutput(json_encode($json));
    }

    // check shipping is right?
    public function is_smilepay_711c2cup($order_id=0)
    {
  
        if(empty($order_id)) $order_id = $this->session->data['order_id'];
        if(!isset($order_id))  return false;

        $this->load->model('checkout/order');  
        $order_info = $this->model_checkout_order->getOrder($order_id);

        if(strpos($order_info['shipping_code'] ,'smilePay_shipping_c2cup.') !== 0) 
          return false;

        return true;
    }
        // check shipping is right?
    public function is_smilepay_711c2cup_now()
    {
  

        if(!isset($this->session->data['shipping_method']['code'])||strpos($this->session->data['shipping_method']['code'],'smilePay_shipping_c2cup.') !== 0) 
          return false;

        return true;
    }
   

    //get store data
    public function getC2cupData()
    {
       return $this->session->data['smilepay_71c2cup_data'];
    }

    protected function modifyOrderAddress($order_id)
    {
        //$this->language->load('payment/smilepay_711c2cup');   
        $this->load->model('checkout/order');  
        $order_info = $this->model_checkout_order->getOrder($order_id);
        $storedata = $this->getC2cupData();

        $order_info['shipping_address_1']= $storedata['storename'] ." (".$storedata['storeid'] .")";
        $order_info['shipping_address_2']= $storedata['storeaddress'];

        $this->db->query("UPDATE `" . DB_PREFIX . "order` SET shipping_address_1 = '" .  $order_info['shipping_address_1'] . "', shipping_address_2 = '". $order_info['shipping_address_2'] ."' WHERE order_id = '" . (int)$order_id . "'");

    }


}
?>
